/* vi:set et ts=4 sw=4 ai ft=c ff=dos: */
#include "temperature.h"

int main ( void )
{
	read_temperature( ) ;
   	return 0 ;
}

void read_temperature ( void )
{
   	uint16_t    temp ;

   	lcd_clrscr( ) ;

   	/* Temp. sensor LM35 is connected to ADC0/PA0 pin of ATmega32 */
   	ADMUX = 0x40 + 0  ;

   	for( ; ; )
    {
    	/* control word and SOC command */
    	ADCSRA = 0xC0 ;

    	/* wait for EOC or while ( ADIF == 0 ) */
    	loop_until_bit_is_set ( ADCSRA, ADIF ) ;

    	temp = ADCW * 49 ;

    	/* go to top left-hand corner of LCD display */
    	lcd_gotoxy ( 0, 0 ) ;

    	lcd_puts_p ( PSTR ( "Temperature\n" ) ) ;
    	lcd_put_i ( temp, 2, 5 ) ;
    	lcd_putc ( ' ' ) ;

    	/* display a 'degree' (small circle as superscript) sign */
    	lcd_putc ( 0xDF ) ;
    	lcd_putc ( 'C' ) ;

    	/* wait for some time before we start next conversion */
    	delay( ) ;
	}
}

void delay ( )
{
    unsigned char i, j, k ;

    for ( i = 0 ; i < 255 ; i++ )
    	for ( j = 0; j < 255 ; j++ )
        	for ( k = 0; k < 246 ; k++ )
           		;
    return ;
}

