/* vi:set et ts=4 sw=4 ai ft=c ff=dos: */
#include "adctime.h"

void avr_init ( void ) ;
void display_temp ( void ) ;
void read_temp ( void ) ;

int main ( void )
{
    avr_init ( ) ;
    lcd_puts_p ( PSTR ( "Temp: " ) ) ;
    read_temp( ) ;
    return 0 ;
}

void avr_init ( void )
{
    lcd_init ( ) ;
    timer_init( ) ;
    sei ( ) ;
    /* Turn off pull-ups */
    DDRA = 0 ;
    PORTA = 0 ;
}

void read_temp ( void )
{
    ADMUX = 0x40 ;
    ADCSRA = 0xC8 ;    /* Enable ADC, Start Conversion, 
                         Enable ADC EOC Interrupt */
}

SIGNAL ( SIG_ADC )
{
    display_temp( ) ;
    timer_start( ) ;
    read_temp( ) ;
}

void display_temp ( void )
{
   uint16_t    count = timer_read_usec( ) ;

   lcd_gotoxy ( 6, 0 ) ;
   lcd_put_i ( ADC * 49 , 2, 5 ) ;
   lcd_putc ( 0xDF ) ;
   lcd_putc ( 'C' ) ;

   lcd_clrline ( 1 ) ;
   lcd_gotoxy ( 0, 1 ) ;
   lcd_puti ( count, 0 ) ;
   lcd_gotoxy ( 3, 1 ) ;
   lcd_puts_p ( PSTR ( "usec" ) ) ;
   _delay_ms ( 300 ) ;
}
