/* vi:set et ts=4 sw=4 ai ft=c ff=dos: */
# include <temperature.h>

uint16_t count ;

int main( void )
{
    lcd_init ( ) ;
    lcd_puts_p ( PSTR ( "Temperature\n" ) ) ;

    sei( ) ;
    start_temp_conv( ) ;
    return 0 ;
}

void start_temp_conv ( void )
{
    /* Temp sensor LM35 is connected to ADC0/PA0 pin of ATmega32 */
    ADMUX = 0x40 ;
    /* Enable ADC, Start Conversion, Enable Interrupt */
    ADCSRA = 0xC8 ;
}

SIGNAL ( SIG_ADC )
{
    display_temp( ) ;
    count++ ;
    start_temp_conv( ) ;
}

void display_temp ( void )
{
    /* Temperature display format is <DD.FF> */
    lcd_gotoxy ( 0, 1 ) ;
    lcd_put_i ( ADC * 48 , 2, 5 ) ;
    lcd_putc ( ' ' ) ;

    /* Displays a 'degree' (small circle as superscript) sign */
    lcd_putc ( 0xDF ) ;
    lcd_putc ( 'C' ) ;
    lcd_puts ( " - " ) ;
    lcd_puti ( count, 0 ) ;
}
