/* vi:set et ts=4 sw=4 ai ft=c ff=dos: */
# include <avr/io.h>
# include <avr/interrupt.h>
# include "lcd_io.h"

unsigned short seconds ;
void start_timer ( void ) ;

int main ( void )
{
    lcd_init ( ) ;
    sei ( ) ;
    start_timer ( ) ;
    return 0 ;
}

void start_timer ( void )
{
    lcd_gotoxy ( 5, 0 ) ;
    lcd_puts ( "Seconds\n" ) ;
    TCNT1 = 0 ;
    TCCR1B = 0x0D ;   /* Divide clock by 1024 = 7.812 kHz, Clear counter
                       on output compare match */
    OCR1A = 7813 ;  /* Count these many cycles */
    TIMSK = 0x10 ;  /* Enable output compare interrupt */
}

SIGNAL ( SIG_OUTPUT_COMPARE1A )
{
    seconds ++ ;
    lcd_gotoxy ( 0, 0 ) ;
    lcd_puti ( seconds, 0 ) ;
}
