/* vi:set et ts=4 sw=4 ai ft=c ff=dos: */
# include "timer_int.h"

unsigned char sig_count ;
unsigned short stop_watch ;

int main ( void )
{
	init_avr( ) ;
	start_timer( ) ;
	return 0 ;
}

void init_avr ( void )
{
	lcd_init( ) ;
	sei( ) ;
}

/*
 * Starts 8 bit timer in interrupt mode
 *
 * Frequency = 8 * 10^6
 * Prescalar = 1024 ==> Freq. scaled down to 7812.5
 * Counter goes from 0 to 255. At 1/125000 sec/cycles,
  * 256 * 1/7812.5 = .032768 sec = 32.768 msec
 * For 1 second we need ~ 31 interrupts
 */

void start_timer ( void )
{
	lcd_gotoxy ( 0, 0 ) ;
	lcd_puts ( "Seconds\n" ) ;

	TCNT0 = 0x00 ;
	TCCR0 = 0x05 ;
	TIMSK = 0x01 ;
}

/* Timer 0 overflow interrupt */
SIGNAL ( SIG_OVERFLOW0 )
{
	sig_count++ ;

	if  ( sig_count == 31 ) 
	{
		stop_watch++ ;
		lcd_gotoxy ( 0, 1 ) ;
		lcd_puts ( "  " ) ;
		lcd_gotoxy ( 0, 1 ) ;
		lcd_puti ( stop_watch, 0 ) ;
		stop_watch = stop_watch % 100 ;
	}
	sig_count = sig_count % 31 ;
}
