/* vi:set et ts=4 sw=4 ai ft=c ff=dos: */
#include "uart1.h"

int main ( void )
{
    char *h = "Hello World\n" ;

    uart_init ( 9600 ) ;
    lcd_init( ) ;

    while ( *h )
    {
        lcd_putc ( *h ) ;
        uart_tx_char ( *h++ ) ;
    }

    while ( 1 )
    {
        unsigned char uch = uart_rx_char( ) ;
        /* Backspace and delete keys are ignored */
        if ( uch != 0x8 && uch != 0x7F )
            lcd_putc ( uch ) ;
    }

    return 0 ;
}

void uart_init ( unsigned int baud )
{
    UBRRH = UART_BAUD_SELECT >> 8 ;
    UBRRL = ( uint8_t ) UART_BAUD_SELECT ;

    /* Enable 8-bit receiver and transmitter */
    UCSRB = _BV( RXEN ) | _BV ( TXEN ) ;
    UCSRC = _BV ( URSEL ) | _BV ( UCSZ1 ) | _BV ( UCSZ0 ) ;
}

void uart_tx_char ( unsigned char s )
{
    /* Wait for data register to be empty */
    loop_until_bit_is_set ( UCSRA , UDRE ) ;
    UDR = s ;
}

unsigned char uart_rx_char ( void )
{
    /* wait for data data word to be received */
    loop_until_bit_is_set ( UCSRA , RXC ) ;
    if ( UCSRA & ( _BV ( PE ) | _BV ( DOR ) | _BV ( FE ) ) )
        return ( unsigned char ) - 1 ;
    return UDR ;
}
