/* vi:set et ts=4 sw=4 ai ft=c ff=dos: */
# ifndef _uart_h_
# define _uart_h_

# include <avr/io.h>
# include <avr/interrupt.h>
# include <inttypes.h>

typedef void ( *INITFUNC_T ) ( void ) ;
typedef void ( *RXFUNC_T ) ( unsigned char ) ;
typedef void ( *TXFUNC_T ) ( unsigned char ) ;

extern void uart_init ( unsigned int baud, uint8_t enable_ints ) ;
extern void uart_tx_char ( unsigned char s ) ;

extern void uart_set_initfunc ( INITFUNC_T ) ;
extern void uart_set_rxfunc ( RXFUNC_T ) ;
extern void uart_set_txfunc ( TXFUNC_T ) ;

# endif  /* _uart_h_ */
