/* vi:set et ts=4 sw=4 ai ft=c ff=dos: */
# ifndef _MENU_H_
# define _MENU_H_

# include <avr/io.h>
# include <avr/interrupt.h>
# include "lcd_io.h"
# include "avrlibtypes.h"
# include "buttons.h"
# include <avr/pgmspace.h>

# define UP         KEY3
# define DOWN       KEY2
# define OK         KEY4
# define CANCEL     KEY5

struct menu_item 
{
    char name[ 16 ] ;
    void ( *func )( void ) ;
} ;

/* Function prototypes */
void display_menu ( struct menu_item *, uint8_t num_items ) ;

# endif   /* _MENU_H_ */
