/* vi:set et ts=4 sw=4 ai ft=c ff=dos: */
# include "menu.h"

void init_avr ( void ) ;
void start_timer ( void ) ;
void print_option1  (void ) ;
void print_option2 ( void ) ;
void print_option3 ( void ) ;
void wait_for_ok ( void ) ;

int main( void )
{
    struct menu_item main_menu[ ] = 
    {
        {  " OPTION 1", print_option1 },
        {  " OPTION 2", print_option2 },
        {  " OPTION 3", print_option3 }
    } ;
    init_avr( ) ;
    display_menu ( main_menu, 
        sizeof ( main_menu ) / sizeof ( main_menu[ 0 ] ) ) ;

    return 0 ;
}

void init_avr ( void )
{
    lcd_init( ) ;
    buttons_init( ) ;
    start_timer( ) ;
    sei( ) ;
}

void start_timer( )
{
    TCNT0 = 0x00 ;
    TCCR0 = 0x05 ;
    TIMSK = 0x01 ;
}

SIGNAL ( SIG_OVERFLOW0 )
{
    buttons_check( ) ;
}

void print_option1 ( void )
{
    lcd_clrscr( ) ;
    lcd_puts ( "OPTION 1 SELECTED" ) ;
    wait_for_ok( ) ;
}

void print_option2 ( void )
{
    lcd_clrscr( ) ;
    lcd_puts ( "OPTION 2 SELECTED" ) ;
    wait_for_ok( ) ;
}

void print_option3 ( void )
{
    lcd_clrscr( ) ;
    lcd_puts ( "OPTION 3 SELECTED" ) ;
    wait_for_ok( ) ;
}

void wait_for_ok( )
{
    while ( key4_state != RELEASED )
        ;
    RESET_KEY_STATE ( key4_state ) ;
}
