/* vi:set et ts=4 sw=4 ai ft=c ff=dos: */

# ifndef _BUTTONS_H_
# define _BUTTONS_H_

# include <compat/deprecated.h>
# include <avr/io.h>

extern uint8_t key2_state ;
extern uint8_t key3_state ;
extern uint8_t key4_state ;
extern uint8_t key5_state ;

/* button states */
# define NOTPRESSED     0x00
# define PRESSED         	0x10
# define RELEASED        	0x01

/* AVR Buttons pin connections */
# define KEY2    PINC7   /* Port C pin */
# define KEY3    PINC6   /* Port C pin */
# define KEY4    PIND2   /* Port D pin */
# define KEY5    PIND3   /* Port D pin */

# define KEY_NOT_PRESSED( addr, b )   bit_is_set(_MMIO_BYTE(addr), b)
# define KEY_PRESSED( addr, b )        bit_is_clear( _MMIO_BYTE(addr), b)
# define RESET_KEY_STATE( k )          (k) = NOTPRESSED

/* Function prototypes */
extern void  buttons_init ( void ) ;
extern int  buttons_check ( void ) ;

# endif  /*_BUTTONS_H_*/
