/* vi:set et ts=4 sw=4 ai ft=c ff=dos: */
#ifndef _rtclib_h_
#define _rtclib_h_

#include <avr/io.h>
#include <stdio.h>
#include <util/delay.h>
#include "twi_driver.h"
#include "lcd_io.h"

typedef struct cTime {
    uint8_t sec ;
    uint8_t min ;
    uint8_t hour ;
    uint8_t day ;
    uint8_t date ;
    uint8_t month ;
    uint8_t year ;
} cTime_t ;

/* DS1307 Slave Address */
#define DS1307_ADDR  	0xD0

static __inline__ uint8_t
bcd_to_bin( uint8_t x )
{
    return ( ( ( x & 0xf0 ) >> 4) * 10 + ( x & 0x0f ) ) ;
}

static __inline__ uint8_t
bin_to_bcd( uint8_t x )
{
    return ( ((x / 10) << 4) | ( x % 10 ) ) ;
}

extern void rtc_init ( void );
extern void rtc_display_time ( void ) ;
extern uint8_t rtc_read_time ( cTime_t *tm ) ;
extern void WriteTimeToLCD ( cTime_t *time ) ;

#endif /* _rtclib_h_ */
