#include "buttons.h"

/* Globals */
uint8_t key2_state;
uint8_t key3_state;
uint8_t key4_state;
uint8_t key5_state;

int check_button(uint8_t *pstate, uint16_t port_addr, uint8_t pin);

/* Enable Pull-up resistor's for port's Pins */
void
buttons_init()
{
    sbi(PORTC, KEY3);
    sbi(PORTC, KEY2);
    sbi(PORTD, KEY4);
    sbi(PORTD, KEY5);
}

int
check_button(uint8_t *pstate, uint16_t port_addr, uint8_t pin)
{
    switch (*pstate) {
    case NOTPRESSED:
        if( KEY_PRESSED(port_addr, pin) ) {
            *pstate = PRESSED;
        }
        break;
    case PRESSED:
        if( KEY_NOT_PRESSED(port_addr, pin) ) {
            *pstate = RELEASED;
            return 1;
        }
        break;
    }
    return 0;
}

int
buttons_check()
{
    int released = 0;

    released |= check_button( &key2_state, _SFR_ADDR(PINC), KEY2 );
    released |= check_button( &key3_state, _SFR_ADDR(PINC), KEY3 );
    released |= check_button( &key4_state, _SFR_ADDR(PIND), KEY4 );
    released |= check_button( &key5_state, _SFR_ADDR(PIND), KEY5 );

    return released;
}
