#include "menu.h"
/* Displays scrollable menu on LCD */
void
display_menu(struct menu_item *m, uint8_t nitems)
{
    uint8_t citem = 0;

    while ( 1 )
    {
        lcd_clrscr();

        lcd_puts(m[citem].name);
        if ((nitems - citem) > 1) {
            lcd_putc('\n');
            lcd_puts(m[citem + 1].name);
        }
        lcd_gotoxy(0, 0);
        lcd_command(LCD_DISP_ON_BLINK);

        if (key4_state == RELEASED) {
            lcd_command(LCD_DISP_ON); /* turn off blinking character */
            RESET_KEY_STATE(key4_state);
            m[citem].func();
        }
        if (key5_state == RELEASED) {
            RESET_KEY_STATE(key5_state);
            /* turn off blinking character */
            lcd_command(LCD_DISP_ON);
            return;
        }
        if (key3_state == RELEASED) {
            RESET_KEY_STATE(key3_state);
            if (citem > 0 ) {
                citem--;
            } else {
                citem = nitems - 1;
            }
        }
        if (key2_state == RELEASED) {
            RESET_KEY_STATE(key2_state);
            if ((nitems - citem) > 1) {
                citem++;
            } else {
                citem = 0;
            }
        }
        _delay_ms(1000);
    }
}

void
display_menu_p( struct menu_item_p *menu, uint8_t nitems )
{
	uint8_t citem = 0;
	
    while ( 1 )
	{
		/* Clear LCD */
		lcd_clrscr();

		/* Display menu items */
		lcd_puts_p(menu[citem].name);
		if ((nitems - citem) > 1) {
			lcd_putc('\n');
			lcd_puts_p(menu[citem + 1].name);
		}
		lcd_gotoxy(0, 0);
		lcd_command(LCD_DISP_ON_BLINK);

		/* Handle button press */
		if (key4_state == RELEASED) {
			/* Reset button state */
			RESET_KEY_STATE(key4_state);
			lcd_command(LCD_DISP_ON); /* turn off blinking character */
			menu[citem].func();
		}
		if (key5_state == RELEASED) {
			/* Reset button state */
			RESET_KEY_STATE(key5_state);
			/* turn off blinking character */
			lcd_command(LCD_DISP_ON);
			return;
		}
		if (key3_state == RELEASED) {
			RESET_KEY_STATE(key3_state);
			if (citem > 0 ) {
				citem--;
			} else {
				citem = nitems - 1;
			}
		}
		if (key2_state == RELEASED) {
			RESET_KEY_STATE(key2_state);
			if ((nitems - citem) > 1) {
				citem++;
			} else {
				citem = 0;
			}
		}
		_delay_ms(1000);
	}
}
